from json import JSONEncoder
import json
from datetime import datetime
from iip.TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.KRec13Anon import KRec13Anon
from datatypes.KRec13AnonImpl import KRec13AnonImpl

class KRec13AnonEncoder(JSONEncoder):
    """JSON encoder class for KRec13Anon.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        return o.__dict__
    

class KRec13AnonSerializer(TypeTranslatorToString):
    """JSON transport serializer for KRec13Anon.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["KRec13Anon"] = self
        Registry.types[KRec13Anon] = "KRec13Anon"
        Registry.serializers["KRec13AnonImpl"] = self # there is a serializer for the Impl
        Registry.types[KRec13AnonImpl] = "KRec13Anon" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> KRec13Anon:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = KRec13AnonImpl()
        result.__dict__ = json.loads(data)
        return result

    def writeTo(self, source: KRec13Anon) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return KRec13AnonEncoder().encode(source).encode("UTF-8").decode()
        
KRec13AnonSerializer()
